#! /usr/local/bin/perl

#############################################################################
# 
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################

$mailprogram="/usr/lib/sendmail -t -n";
$author="sevilgen\@top.cis.syr.edu";
$signature="<font size=-1><i>Fatih E. Sevilgen Inc.</i></font>";
%month=(begin,"00",Jan,"01",Feb,"02",Mar,"03",Apr,"04",May,"05",Jun,"06",Jul,"07",Aug,"08",Sep,"09",Oct,"10",Nov,"11",Dec,"12",end,"13");
#
# fields ------------------------------------------------
#  call accounts
#
$ROOM=0;
$NAME=1;
$EMAIL=2;
$FROMDATE=3;
$FROMTIME=4;
$TODATE=5;
$TOTIME=6;
$REMARKS=7;

$filename="reservations.database";
$verified=0;

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;
&openHtml;
&ReadEntry && &EXECUTE;
&closeHtml;
#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form

   $date = `date`;
   @default_dates = split( /\s+/ , $date);

   $orgName = ($in{'OrgName'}) ? $in{'OrgName'} : -1;
   $email = ($in{'email'}) ? $in{'email'} : -1;
   $room = ($in{'room'}) ? $in{'room'} : -1; 
   $fromDay  = ($in{'fromDay'}) ? $in{'fromDay'} : $default_dates[2];
   $fromMonth  = ($in{'fromMonth'}) ? $in{'fromMonth'} : $default_dates[1];;
   $fromYear = ($in{'fromYear'}) ? $in{'fromYear'} : $default_dates[5];
   $toDay = ($in{'toDay'}) ? $in{'toDay'} : '00';
   $toMonth = ($in{'toMonth'}) ? $in{'toMonth'} : '00';
   $toYear = ($in{'toYear'}) ? $in{'toYear'} : '0000';
   $fromHour = ($in{'fromTime'}) ? $in{'fromTime'} : 0 ;
   $fromAMPM = ($in{'fromAMPM'}) ? $in{'fromAMPM'} : "AM";
   $toHour = ($in{'toTime'}) ? $in{'toTime'} : 13;
   $toAMPM = ($in{'toAMPM'}) ? $in{'toAMPM'} : "PM";
   $remarks = ($in{'remarks'}) ? $in{'remarks'} : "N/A";

   $checkedTo = ($in{'to'}) ? 1 : 0;
   if ($checkedTo == 0) { 
       $toDay = $fromDay;
       $toMonth = $fromMonth;
       $toYear = $fromYear;
   }       
   
   $fromDay  = ($fromDay<10) ? "0".$fromDay : $fromDay;
   $toDay = ($toDay<10) ? "0".$toDay : $toDay;
   
   $fromDate=$fromYear.$month{ substr($fromMonth, 0, 3) }.$fromDay;
   $toDate=$toYear.$month{ substr($toMonth, 0, 3) }.$toDay;
   $fromTime=&convertTime2Number($fromHour,$fromAMPM);
   $toTime=&convertTime2Number($toHour,$toAMPM);

   if($fromDate > $toDate) {
       print "<table><tr><td><b><font color=red>Invalid date entry! Please check the dates. </font></b></td></tr></table>";
       return 0;
   }

   if($fromTime >= $toTime) {
       print "<table><tr><td><b><font color=red> Invalid time entry! Please check the times.</font></b></td></tr></table>";
       return 0;
   }
       
   return 1;
}

sub convertTime2Number {
     local ($hour,$ampm)=@_;
     if ($ampm eq "PM") {
        if ($hour==12) {;}
        else {$hour+=12};
     } else { if ($hour==12) {$hour="00";}  }
     $n=$hour."00";
     $n = ($n < 1000) ? "0".$n : $n; 
     return $n;
}
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
sub EXECUTE {
	&scanFile($filename);
	if ($verified != 0) {
 	       print "<table bgcolor=yellow><tr><td><b> Room Reserved, an email will be sent to you about the details</b></td></tr></table>";
	       open(MAIL, "|$mailprogram");
	       print MAIL "From: $author\n";
	       print MAIL "To: \"$orgName\" \<$email\>\n";
	       print MAIL "Cc: $author\n";
	       print MAIL "Subject: Your reservation\n\n";
	       print MAIL "Your reservation has been confirmed based on the following information:\n";
	       print MAIL "Organization Name  : $orgName\n";
	       print MAIL "Your Email Address : $email\n";
	       print MAIL "Reserved Room \#   : $room\n\n";
	       print MAIL "Day from $fromDay $fromMonth $fromYear \n";
	       print MAIL "Day   to $toDay $toMonth $toYear \n";
	       print MAIL "Between $fromHour $fromAMPM to $toHour $toAMPM\n\n";
	       print MAIL "Remarks\n";
	       print MAIL "$remarks\n\n";
	       print MAIL "If this information is not correct, please do not hesitate to contact us!\n";
	       close(MAIL);	       

	       &recordFile($filename);
	} else {
	    print " <font size=+1 color=red>Sorry, the Room \# $room is not availbale at that time period...</font><br>";
	}
    }
#
##############################################################################
#  recordFile: save the reservation data to the database
#
##############################################################################
sub recordFile {
    local($fn)=@_;
    open(OUT, ">> $fn"); 
    print OUT "$room|$orgName|$email|$fromDate|$fromTime|$toDate|$toTime|$remarks\n";
    close(OUT);
}

##############################################################################
#  scanFile: process each file in the directory
#
##############################################################################
sub scanFile {
    local($fn)=@_;
    open(IN, "$fn"); 
    $verified=1;
    while ( ($line=<IN>) && ($verified !=0)) {
	chop($line);
        @fields = split ( /\|/, $line );
        if(($fields[$ROOM] == $room) && 
	   !( ($fields[$FROMDATE] > $toDate) || ($fields[$TODATE] < $fromDate)) &&
	   !( ($fields[$FROMTIME] >= $toTime) || ($fields[$TOTIME] <= $fromTime)) ) {
	    $verified=0; 
	}
    }
    close(IN);
}


#
##############################################################################
#
# Results
#
##############################################################################

# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}
sub printFooter {
  print "$signature </body></html>\n";
}

sub closeTable {
print "</table>";
}

sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title>Reservation Results </title>
</HEAD>
<body
background="http://osprey7.npac.syr.edu:3768/cps606spring98-docs/co98fes/alien.gif">
<H1>Reservasion Information for the host $ENV{'REMOTE_HOST'}; 
</h1>
EOF
}
sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}


##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}
